<html>
<head>
<title>OgreD3D11HardwareBufferManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11HardwareBufferManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11HardwareBufferManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11HARWAREBUFFERMANAGER_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11HARWAREBUFFERMANAGER_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBufferManager_8h.html">OgreHardwareBufferManager.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 
<a name="l00037"></a><a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html">00037</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html" title="Implementation of HardwareBufferManager for D3D11.">D3D11HardwareBufferManagerBase</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039     <span class="keyword">protected</span>:
<a name="l00040"></a><a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a99c13bc887c37c463dccb4daeda8a313">00040</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a99c13bc887c37c463dccb4daeda8a313">mlpD3DDevice</a>;
<a name="l00041"></a>00041 
<a name="l00043"></a>00043         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a26c3ea300731178e289ead7c9729bcd5" title="Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs...">createVertexDeclarationImpl</a>(<span class="keywordtype">void</span>);
<a name="l00045"></a>00045         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a2364c8d9471f82ec0b3511f1ce74f622" title="Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs...">destroyVertexDeclarationImpl</a>(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047     <span class="keyword">public</span>:
<a name="l00048"></a>00048         <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a9cc184ad9b6652ab2f8a646e5c2c924b">D3D11HardwareBufferManagerBase</a>(<a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device);
<a name="l00049"></a>00049         <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a9a4ca77026a040d4e2dbdfcb2b9da1c7">~D3D11HardwareBufferManagerBase</a>();
<a name="l00051"></a>00051         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> 
<a name="l00052"></a>00052             <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a8eda1c9525867a1dac211d0940d2c268" title="Creates a vertex buffer.">createVertexBuffer</a>(<span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVerts, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useShadowBuffer = <span class="keyword">false</span>);
<a name="l00054"></a>00054         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> 
<a name="l00055"></a>00055             <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a56de33270a1c5a884b2f17b3f0c2bcd0" title="Creates a stream output vertex buffer.">createStreamOutputVertexBuffer</a>(<span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVerts, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useShadowBuffer = <span class="keyword">false</span>);
<a name="l00057"></a>00057         <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> 
<a name="l00058"></a>00058             <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a00e21835460b7e91ee8df594de755dc8" title="Create a hardware vertex buffer.">createIndexBuffer</a>(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a> itype, <span class="keywordtype">size_t</span> numIndexes, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useShadowBuffer = <span class="keyword">false</span>);
<a name="l00060"></a>00060         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">RenderToVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#afc16a26d6cfd596c619461dfb785c861">createRenderToVertexBuffer</a>();
<a name="l00061"></a>00061 
<a name="l00066"></a>00066         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a784fbae3368ace0e80ce7f89f9b6a532" title="Release all buffers in the default memory pool.">releaseDefaultPoolResources</a>(<span class="keywordtype">void</span>);
<a name="l00071"></a>00071         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html#a0135a2584ab283b30f9e519d2e4766ff" title="Recreate all buffers in the default memory pool.">recreateDefaultPoolResources</a>(<span class="keywordtype">void</span>);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     };
<a name="l00074"></a>00074 
<a name="l00076"></a><a class="code" href="classOgre_1_1D3D11HardwareBufferManager.html">00076</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HardwareBufferManager.html" title="D3D11HardwareBufferManagerBase as a Singleton.">D3D11HardwareBufferManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078     <span class="keyword">public</span>:
<a name="l00079"></a><a class="code" href="classOgre_1_1D3D11HardwareBufferManager.html#a77128c51e93ae99675ea89c01862eab6">00079</a>         <a class="code" href="classOgre_1_1D3D11HardwareBufferManager.html#a77128c51e93ae99675ea89c01862eab6">D3D11HardwareBufferManager</a>(<a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device)
<a name="l00080"></a>00080             : <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>(<a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1D3D11HardwareBufferManagerBase.html" title="Implementation of HardwareBufferManager for D3D11.">D3D11HardwareBufferManagerBase</a>(device)) 
<a name="l00081"></a>00081         {
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         }
<a name="l00084"></a><a class="code" href="classOgre_1_1D3D11HardwareBufferManager.html#a4c952da88aa1bba59c607fee6207ec7a">00084</a>         <a class="code" href="classOgre_1_1D3D11HardwareBufferManager.html#a4c952da88aa1bba59c607fee6207ec7a">~D3D11HardwareBufferManager</a>()
<a name="l00085"></a>00085         {
<a name="l00086"></a>00086             <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> <a class="code" href="classOgre_1_1HardwareBufferManager.html#a154ee1cdff3ec67765532601ad272cb8">mImpl</a>;
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088     };
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
